/*-------------------------------------------------------------------------------------------------
Author     : 
Company    : Husky Energy
Description: 
Inputs     : N/A
Test Class : VTT_TradesmanScheduleControllerTest
History    : 07-Nov-17 mz: commented filtering of activities based on user status       
             07-Nov-17 mj: add changes for displaying additional data in activityCalendar
             03-Jan-18 mz: removed commented code for filtering activities and updating it with updated condition 
                           to use filter on specific user status only if activity is thermal (W-000949)
             09-Feb-18 mz: incorporated SAP sub-statuses for 2SCH %FIX% for thermal activities (W-001008)
             30-May-18 mz: Initial work for W-001091 - list of on hold activities in Calendar
             05-Jun-18 mz: Some refactoring, removed dead code, added some comments, fixed and unified formatting
             07-Jun-18 mz: Made link for Work Order as well & Added different level of location into Work Order Summmary - there was just "Location" before
             08-Jun-18 mz: Made Work Log Activities (Activity Events in calendar) unique -> showing only newest
            ---------------------------------------------------------------------------------------------------*/ 
public without sharing class VTT_TradesmanScheduleController {
    
    public final static String TAG = 'VTT_Utilities';
    
    public Contact Tradesman {get; set;}
    public ID TradesmanID {get; set;}   
   
    public String AccountID {get; set;}
    public String filterOption {get; set;}

    public List<SelectOption> VendorAccoountOptions {get; private set;}
    public List<SelectOption> TradesmenOptions {get; private set;}

    public List<Work_Order_Activity__c> onHoldActivityList {get; private set;}
    public List<Work_Order_Activity_Log_Entry__c> LogEntryList {get; set;}
    public List<WorkOrderSummary> WorkOrderSummaryList {get;set;}
    public List<calEvent> events {get;set;}
    
    public String CurrentDate {get; set;}
    
    public Decimal TotalHours {get; set;}
    public String TotalHoursText {get; set;}    

    public Decimal TotalHoursOnEquipment {get; set;}
    public String TotalHoursOnEquipmentText {get; set;}    

    public Decimal TotalHoursOffEquipment {get; set;}
    public String TotalHoursOffEquipmentText {get; set;}    

    public Boolean IsVendorSupervisor {get;private set;}    
    public Boolean IsAdmin {get;private set;}

    private Set<ID> workedActivitySet = new set<ID>(); 
    
  
    //The calendar plugin is expecting dates is a certain format. We can use this string to get it formated correctly
    //String dtFormat = 'EEE, d MMM yyyy HH:mm:ss z';
    //for IE9
    String dtFormat = 'yyyy-MM-dd\'T\'HH:mm:ss\'Z\'';
    //String dtFormat = 'yyyy-mm-dd HH:mm:ss z';

    //constructor
    public VTT_TradesmanScheduleController() {

        AccountID = null;
        TradesmanID = null;
        events = new list<calEvent>();
        filterOption = 'Vendor';

        IsAdmin = VTT_Utilities.IsAdminUser();
        IsVendorSupervisor = VTT_Utilities.IsVendorSupervisor();
        Tradesman = VTT_Utilities.LoadTradesmanInfo();

        String vendorIdString =  ApexPages.CurrentPage().getParameters().get('VendorID');
        String tradesmanIdString =  ApexPages.CurrentPage().getParameters().get('TradesmanID');  

        if(IsAdmin){
            
            LoadVendorAccountList();
            
            if (vendorIdString!=null){
                AccountID = vendorIdString;
            }
            else if (VendorAccoountOptions.size()>0){
                AccountID = Tradesman.AccountID <> null? Tradesman.AccountID : VendorAccoountOptions[0].getValue();
            }
            LoadTradesmanList();
            if (tradesmanIdString!=null){
                TradesmanID = tradesmanIdString;
            }
            else if (TradesmenOptions.size()>0){
                TradesmanID =  Tradesman.id <> null?  Tradesman.id : TradesmenOptions[0].getValue();                
            }
        }
        
        else if (IsVendorSupervisor){
            AccountID =  Tradesman.AccountID;
            LoadTradesmanList();
            
            if(tradesmanIdString!=null){
                TradesmanID = tradesmanIdString;
            }
            else if(TradesmenOptions.size()>0){
                TradesmanID = Tradesman.id <> null?  Tradesman.id : TradesmenOptions[0].getValue();                
            }       
        }
        else {
            AccountID =  Tradesman.AccountID;
            TradesmanID = Tradesman.id; 
        }

        System.debug(TAG + 'VTT_TradesmanScheduleController -> AccountID: ' + AccountID);
        System.debug(TAG + 'VTT_TradesmanScheduleController -> TradesmanID: ' + TradesmanID); 

        ReloadEvents(); 

        Datetime currentDatetime = Datetime.now();
        CurrentDate = currentDatetime.format('yyyy-MM-dd'); 
        LogEntryList = new List<Work_Order_Activity_Log_Entry__c>();
        ReloadLogEntries();
    }
    

    public PageReference PageReload(){
        
        PageReference pageRef = ApexPages.currentPage();
        pageRef.setRedirect(true);
        pageRef.getParameters().put('VendorID', AccountID);
        pageRef.getParameters().put('TradesmanID', TradesmanID); 
        return pageRef;  
    }
    

    public PageReference JobInProgress(){
        
        PageReference pageRef = new PageReference('/apex/VTT_ActivityDetailTimeLog?id=' + Tradesman.Current_Work_Order_Activity__c);
        pageRef.setRedirect(true);
        return pageRef;      
    }
    

    public void LoadVendorAccountList(){
        
        events = new list<calEvent>();
        
        if(IsAdmin){
            VendorAccoountOptions = new List<SelectOption>();
            for(Account accountRec: VTT_Utilities.GetVendorAccountList()){
                SelectOption accOption = new SelectOption(accountRec.id, accountRec.Name);
                VendorAccoountOptions.add(accOption);
            }  
        } 
        else{
            AccountID = Tradesman.AccountId;
        }
    }
    

    public void LoadTradesmanList(){
        
        events = new list<calEvent>();
        TradesmenOptions = new List<SelectOption>();
        TradesmanID = null;
        LoadMyOnHoldActivities();

        if((IsVendorSupervisor || isAdmin) && AccountID <> null){

            List<Contact> contactList = [SELECT Id, name 
                                         FROM Contact WHERE
                                         AccountID = :AccountID 
                                         AND User__c <> null 
                                         ORDER BY name 
                                         LIMIT 5000];

            for(Contact contactRec: contactList){

                if(TradesmanID == null){
                    TradesmanID = contactRec.id;
                }
                SelectOption accOption = new SelectOption(contactRec.id, contactRec.Name);
                TradesmenOptions.add(accOption);                               
            }  
        }  
    }
    

    public void ReloadEvents(){
        
        System.debug(TAG + 'ReloadEvents() called');
        System.debug(TAG + 'VTT_TradesmanScheduleController -> AccountID: ' + AccountID);
        System.debug(TAG + 'VTT_TradesmanScheduleController -> TradesmanID: ' + TradesmanID); 
        
        LogEntryList = new List<Work_Order_Activity_Log_Entry__c>();        
        events  =  new list<calEvent>(); 

        LoadMyActivityWorkLogs();
        LoadMyScheduledActivities();
        LoadMyOnHoldActivities();
        
        System.debug(TAG + 'ReloadEvents() called -> events count: ' + events.size());
    }


    //VF rendering property for on hold activity list
    public Boolean ShowOnHoldActivities{
        get {
            if (onHoldActivityList != null && onHoldActivityList.Size() > 0){
                return true;
            }
            return false;
        }
        private set;
    }
    
    
    //create URL to Activity List View Page to view On Hold Activities with prepopulated Vendor and Tradesman Filters
    public String onHoldActivitiesURLString{
        get {
            if (AccountID != null && TradesmanID != null){
                String onHoldActivitiesURLString = '/apex/VTT_ActivityListView?filter=%7B%22vendorFilter%22%3A%22' + AccountID +
                                                    '%22%2C%22tradesmanFilter%22%3A%22' + TradesmanID +
                                                    '%22%2C%22hideONHOLDFilter%22%3Afalse%2C%22hideCompletedFilter%22%3Atrue%2C%22activityMultiStatusFilter%22%3A%5B%22On+Hold%22%5D%7D';
                return onHoldActivitiesURLString;
            }
            return null;
        }
        private set;
    }
    
    
    //Load List of On Hold Activities Assigned to Tradesman
    public List<Work_Order_Activity__c> LoadMyOnHoldActivities(){
        
        onHoldActivityList = new List<Work_Order_Activity__c>();

        if (AccountID !=null && TradesmanID !=null){
            
            onHoldActivityList  = [SELECT Id, Name, Scheduled_Start_Date__c, Status__c,
                                          (SELECT Date__c, Work_Order_Activity__r.Status__c 
                                           FROM Work_Order_Activity_Logs__r 
                                           ORDER BY Date__c DESC 
                                           LIMIT 1)
                                  FROM Work_Order_Activity__c
                                  WHERE Id IN (SELECT Work_Order_Activity__c 
                                               FROM Work_Order_Activity_Assignment__c 
                                               WHERE Rejected__c <> true 
                                               AND Tradesman__c =:TradesmanID)
                                  AND SAP_deleted__c = false
                                  AND Status__c = :VTT_Utilities.ACTIVITY_STATUS_ONHOLD
                                  ORDER BY Scheduled_Start_Date__c DESC
                                  LIMIT 1000];
        }                      
        return onHoldActivityList;                     
    }
    
    
    private void LoadMyScheduledActivities()
    {
        //TODO: load scheduled information for assigned to me activities starting today
        List<Work_Order_Activity__c> activityList = [SELECT ID, Name, Scheduled_Start_Date__c, Scheduled_Finish_Date__c, 
                                                            Maintenance_Work_Order__c, User_Status__c, Status__c, 
                                                            Maintenance_Work_Order__r.Work_Order_Priority_Number__c,
                                                            Maintenance_Work_Order__r.Work_Order_Number__c,
                                                            Maintenance_Work_Order__r.Well_Event__c,
                                                            Maintenance_Work_Order__r.Well_Event__r.Name,
                                                            Maintenance_Work_Order__r.Functional_Equipment_Level__c,
                                                            Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name,
                                                            Maintenance_Work_Order__r.Yard__c,
                                                            Maintenance_Work_Order__r.Yard__r.Name,
                                                            Maintenance_Work_Order__r.Sub_System__c,
                                                            Maintenance_Work_Order__r.Sub_System__r.Name,
                                                            Maintenance_Work_Order__r.System__c,
                                                            Maintenance_Work_Order__r.System__r.Name,
                                                            Maintenance_Work_Order__r.Facility__c,
                                                            Maintenance_Work_Order__r.Facility__r.Name,
                                                            Maintenance_Work_Order__r.Location__c,
                                                            Maintenance_Work_Order__r.Location__r.Name,
                                                            Operating_Field_AMU__c, Operating_Field_AMU__r.Is_Thermal__c,
                                                            Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c,
                                                            Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c
                                                     FROM Work_Order_Activity__c 
                                                     WHERE 
                                                     Id IN (select Work_Order_Activity__c from Work_Order_Activity_Assignment__c where Rejected__c <> true and Tradesman__c =:TradesmanID)
                                                     AND Scheduled_Start_Date__c >= LAST_N_DAYS:30
                                                     AND id not in :workedActivitySet
                                                     AND SAP_deleted__c = false
                                                     AND Status__c <> :VTT_Utilities.ACTIVITY_STATUS_COMPLETED
                                                     //mz 3-Jan-18
                                                     AND (((Operating_Field_AMU__c != null 
                                                            AND ((Operating_Field_AMU__r.Is_Thermal__c = true 
                                                                  AND (User_Status__c LIKE '2SCH %FIX%' 
                                                                       OR User_Status__c LIKE '3BEX%')) 
                                                            OR Operating_Field_AMU__r.Is_Thermal__c = false))
                                                           OR (Operating_Field_AMU__c = null 
                                                               AND Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c != null 
                                                                   AND ((Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c = true 
                                                                         AND (User_Status__c LIKE '2SCH %FIX%' 
                                                                         OR User_Status__c LIKE '3BEX%')) 
                                                                    OR Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c = false))
                                                           OR (Operating_Field_AMU__c = null 
                                                               AND Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c = null)))
                                                     ORDER BY Scheduled_Start_Date__c
                                                     LIMIT 1000];

        for(Work_Order_Activity__c activity : activityList){
            
            DateTime startDT = activity.Scheduled_Start_Date__c;
            DateTime endDT = activity.Scheduled_Finish_Date__c;
            if(endDT==null){
                
                endDT = DateTime.now();
            }
            if(startDT <> null && endDT <> null){
                
                calEvent campEvent = new calEvent();
                campEvent.title = activity.Name;
                campEvent.allDay = false;
                campEvent.startString = startDT.format(dtFormat);
                campEvent.endString = endDT.format(dtFormat);
                campEvent.url = 'VTT_ActivityDetailTimeLog?id=' + activity.id + 
                                '&retUrl=' + EncodingUtil.urlEncode('/apex/VTT_TradesmanCalendar?VendorID=' + 
                                 AccountID + '&TradesmanID=' + 
                                 TradesmanID, 'UTF-8');
                                 
                if(activity.Status__c == VTT_Utilities.ACTIVITY_STATUS_ONHOLD){
                    campEvent.className = 'event-activitylog-onHold-rescheduled';
                }
                else{
                    campEvent.className = 'event-scheduled';
                }
                campEvent.activityId = activity.Id;
                campEvent.woWONumber = activity.Maintenance_Work_Order__r.Work_Order_Number__c;
                campEvent.woPriorityNumber = activity.Maintenance_Work_Order__r.Work_Order_Priority_Number__c;
                campEvent.woFlocType = '';
                
                if (activity.Maintenance_Work_Order__r.Well_Event__c != null) {
                    //CAT 9 -> Well Event
                    campEvent.woFlocType = Well_Event__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.Well_Event__r.Name;
                } 
                else if (activity.Maintenance_Work_Order__r.Yard__c != null) {
                    //CAT 8 - Yard
                    campEvent.woFlocType = Yard__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.Yard__r.Name;
                } 
                else if (activity.Maintenance_Work_Order__r.Functional_Equipment_Level__c != null) {
                    //CAT 7 - FEL
                    campEvent.woFlocType = Functional_Equipment_Level__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name;
                } 
                else if (activity.Maintenance_Work_Order__r.Sub_System__c != null) {
                    //CAT 6 - Subsystem
                    campEvent.woFlocType = Sub_System__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.Sub_System__r.Name;
                } 
                else if (activity.Maintenance_Work_Order__r.System__c != null) {
                    //CAT 5 - System
                    campEvent.woFlocType = System__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.System__r.Name;
                } 
                else if (activity.Maintenance_Work_Order__r.Location__c != null) {
                    //CAT 4 - Location
                    campEvent.woFlocType = Location__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.Location__r.Name;
                } 
                else if (activity.Maintenance_Work_Order__r.Facility__c != null) {
                    // CAT 3 - Facility
                    campEvent.woFlocType = Facility__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = activity.Maintenance_Work_Order__r.Facility__r.Name;
                }
                 events.add(campEvent);

            }
        }
    }


    private void LoadMyActivityWorkLogs(){

        System.debug(TAG + ' LoadMyActivityWorkLogs() -> TradesmanID: ' + TradesmanID);
        workedActivitySet = new Set<ID>();
        Set<Id> workLogActivitySet = new Set<Id>();
        Map<Id,Work_Order_Activity_Log__c> workLogMap = new Map<Id,Work_Order_Activity_Log__c>();

        List<Work_Order_Activity_Log__c> workLogList = [SELECT ID, Work_Order_Activity__c, 
                                                                Work_Order_Activity__r.Name, Started_New__c, Finished_New__c, Date__c,
                                                                Work_Order_Activity__r.Scheduled_Start_Date__c,
                                                                Work_Order_Activity__r.Status__c,
                                                                Work_Order_Activity__r.User_Status__c,
                                                                Work_Order_Activity__r.Finished__c, 
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Priority_Number__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__r.Name,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__r.Name,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__r.Name,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.System__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.System__r.Name,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__r.Name,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Location__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Location__r.Name,
                                                                Work_Order_Activity__r.Operating_Field_AMU__c,
                                                                Work_Order_Activity__r.Operating_Field_AMU__r.Is_Thermal__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c,
                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c,
                                                                (SELECT Id, Name, Status__c,
                                                                        Work_Order_Activity_Log_Entry__c.TimeStamp__c 
                                                                 FROM Work_Order_Activity_Log_Entries2__r 
                                                                 ORDER BY TimeStamp__c DESC
                                                                 LIMIT 1)
                                                        FROM Work_Order_Activity_Log__c 
                                                        WHERE Tradesman__c = :TradesmanID
                                                        AND Date__c = LAST_90_DAYS
                                                        AND Started_New__c <> null
                                                        //mz 3-Jan-18
                                                        AND (((Work_Order_Activity__r.Operating_Field_AMU__c != null 
                                                               AND ((Work_Order_Activity__r.Operating_Field_AMU__r.Is_Thermal__c = true 
                                                                     AND (Work_Order_Activity__r.User_Status__c LIKE '2SCH %FIX%' 
                                                                          OR Work_Order_Activity__r.User_Status__c LIKE '3BEX%' 
                                                                          OR (Work_Order_Activity__r.User_Status__c LIKE '4COM%' 
                                                                              AND Work_Order_Activity__r.Status__c = 'Completed'))) 
                                                                     OR Work_Order_Activity__r.Operating_Field_AMU__r.Is_Thermal__c = false)))
                                                             OR ((Work_Order_Activity__r.Operating_Field_AMU__c = null 
                                                                  AND Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c != null 
                                                                  AND ((Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c = true 
                                                                        AND (Work_Order_Activity__r.User_Status__c LIKE '2SCH %FIX%' 
                                                                             OR Work_Order_Activity__r.User_Status__c LIKE '3BEX%' 
                                                                             OR(Work_Order_Activity__r.User_Status__c LIKE '4COM%' 
                                                                                AND Work_Order_Activity__r.Status__c = 'Completed'))) 
                                                                 OR Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c = false)))
                                                             OR (Work_Order_Activity__r.Operating_Field_AMU__c = null 
                                                                AND Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c = null))
                                                        ORDER BY Date__c ASC
                                                        LIMIT 1000];
        
        //make work log unique -> loopin thru the list & putting into map to overwrite older work logs and keep the newest (based on the Date__c)
        for(Work_Order_Activity_Log__c workLog : workLogList){
           workLogMap.put(workLog.Work_Order_Activity__c,workLog);
        }
        
        for(Work_Order_Activity_Log__c workLog : workLogMap.values())
        {
            System.debug(TAG  + ' LoadMyActivityWorkLogs() -> ActivityLog: ' + 
                         workLog.Work_Order_Activity__r.Name + 
                         ' Started_New__c: ' + workLog.Started_New__c);
            //add activity ID to the set so we can use it later in 
            //LoadMyScheduledActivities in order to ignore scheduled activities if  Tradesman already working on it
            workedActivitySet.add(workLog.Work_Order_Activity__c);
            workLogActivitySet.add(workLog.Id);

            Boolean eventProblem = false;
            DateTime startDT = workLog.Started_New__c;
            DateTime endDT = workLog.Finished_New__c;
            if (workLog.Work_Order_Activity_Log_Entries2__r != null && 
                workLog.Work_Order_Activity_Log_Entries2__r.Size() > 0 &&
                workLog.Work_Order_Activity_Log_Entries2__r[0].Status__c == VTT_Utilities.LOGENTRY_JOBONHOLD){
                endDT = workLog.Work_Order_Activity_Log_Entries2__r[0].TimeStamp__c;
            }
        
            if(endDT==null){
                
                if(startDT.date() == Date.today()){
                    endDT = DateTime.now();                    
                }
            }
            
            if(startDT <> null && endDT <> null){
                
                calEvent campEvent = new calEvent();
                campEvent.title = workLog.Work_Order_Activity__r.Name;
                campEvent.allDay = false;
                campEvent.startString = startDT.format(dtFormat);
                campEvent.endString = endDT.format(dtFormat);
                campEvent.url = 'VTT_ActivityDetailTimeLog?id=' + workLog.Work_Order_Activity__c +
                                '&retUrl=' + EncodingUtil.urlEncode('/apex/VTT_TradesmanCalendar?VendorID=' + AccountID +
                                '&TradesmanID=' + TradesmanID, 'UTF-8');

                if(workLog.Work_Order_Activity__r.Status__c == VTT_Utilities.ACTIVITY_STATUS_COMPLETED){
                    campEvent.className = 'event-activitylog-complete';
                }
                //On Hold Activities -> if Scheduled Start Date is lower or Equal as On Hold Date we will display only activity with On Hold Date on calendar (gray one)
                else if(workLog.Work_Order_Activity_Log_Entries2__r[0].Status__c == VTT_Utilities.LOGENTRY_JOBONHOLD &&
                        workLog.Work_Order_Activity__r.Scheduled_Start_Date__c.date() <= endDT){
                    campEvent.startString = endDT.format(dtFormat);
                    campEvent.className = 'event-activitylog-onHold';
                }
                //On Hold Activities -> if Scheduled Start Date is Higher than On Hold Date we will display activity start date
                //and will disaply both On Hold Activity (gray) and On Hold Re-Shheduled activity placeholder (yellow one) on Activity calendar 
                else if(workLog.Work_Order_Activity_Log_Entries2__r[0].Status__c == VTT_Utilities.LOGENTRY_JOBONHOLD &&
                        workLog.Work_Order_Activity__r.Scheduled_Start_Date__c.date() > endDT){
                    workedActivitySet.remove(workLog.Work_Order_Activity__c);
                    campEvent.startString = endDT.format(dtFormat);
                    campEvent.className = 'event-activitylog-onHold';
                }
                else{
                    campEvent.className = 'event-activitylog';
                }
                campEvent.activityId = worklog.Work_Order_Activity__c;
                campEvent.woPriorityNumber = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Priority_Number__c;
                campEvent.woWONumber = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c;
                campEvent.woFlocType = '';

                if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__c != null) {
                    //CAT 9 -> Well Event
                    campEvent.woFlocType = Well_Event__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__c != null) {
                    //CAT 8 - Yard
                    campEvent.woFlocType = Yard__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__c != null) {
                    //CAT 7 - FEL
                    campEvent.woFlocType = Functional_Equipment_Level__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__c != null) {
                    //CAT 6 - Subsystem
                    campEvent.woFlocType = Sub_System__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.System__c != null) {
                    //CAT 5 - System
                    campEvent.woFlocType = System__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.System__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Location__c != null) {
                    //CAT 4 - Location
                    campEvent.woFlocType = Location__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Location__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__c != null) {
                    //CAT 3 - Facility
                    campEvent.woFlocType = Facility__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__r.Name;
                }
                events.add(campEvent);
            }
        }
        
        //handle Stale Activities only
        List<Work_Order_Activity_Log__c> workLogStaleActivitiesList =   [SELECT Id, Work_Order_Activity__c, 
                                                                                Work_Order_Activity__r.Name, Started_New__c, Finished_New__c,
                                                                                Work_Order_Activity__r.Status__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Priority_Number__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__r.Name,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__r.Name,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__r.Name,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.System__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.System__r.Name,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__r.Name,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Location__c,
                                                                                Work_Order_Activity__r.Maintenance_Work_Order__r.Location__r.Name,
                                                                                (SELECT Id, Name, Status__c 
                                                                                 FROM Work_Order_Activity_Log_Entries2__r 
                                                                                 WHERE Status__c = :VTT_Utilities.LOGENTRY_AUTOCOMPLETE) 
                                                                       FROM Work_Order_Activity_Log__c
                                                                       WHERE Id IN :workLogActivitySet];
        
        for(Work_Order_Activity_Log__c workLog : workLogStaleActivitiesList){
            
            Boolean eventProblem = false;
            DateTime startDT = workLog.Started_New__c;
            DateTime endDT = workLog.Finished_New__c;
            
            if(endDT==null){
                
                if(startDT.date() == Date.today()){
                    endDT = DateTime.now();                    
                }
                else if(workLog.Work_Order_Activity_Log_Entries2__r == null || 
                        workLog.Work_Order_Activity_Log_Entries2__r.size() == 0){
                    endDT = startDT + 1/24; // add one hour
                    eventProblem = true;
                }
                
            }
            
            if((startDT <> null && endDT <> null) && eventProblem){
                
                calEvent campEvent = new calEvent();
                campEvent.title = workLog.Work_Order_Activity__r.Name;
                campEvent.allDay = false;
                campEvent.startString = startDT.format(dtFormat);
                campEvent.endString = endDT.format(dtFormat);
                campEvent.url = 'VTT_ActivityDetailTimeLog?id=' + workLog.Work_Order_Activity__c +
                                '&retUrl=' + EncodingUtil.urlEncode('/apex/VTT_TradesmanCalendar?VendorID=' + AccountID +
                                '&TradesmanID=' + TradesmanID, 'UTF-8');

                campEvent.className = 'event-activitylog-err';
                campEvent.activityId = worklog.Work_Order_Activity__c;
                campEvent.woPriorityNumber = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Priority_Number__c;
                campEvent.woWONumber = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c;
                campEvent.woFlocType = '';

                if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__c != null) {
                    //CAT 9 -> Well Event
                    campEvent.woFlocType = Well_Event__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__c != null) {
                    //CAT 8 - Yard
                    campEvent.woFlocType = Yard__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__c != null) {
                    //CAT 7 - FEL
                    campEvent.woFlocType = Functional_Equipment_Level__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__c != null) {
                    //CAT 6 - Subsystem
                    campEvent.woFlocType = Sub_System__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.System__c != null) {
                    //CAT 5 - System
                    campEvent.woFlocType = System__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.System__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Location__c != null) {
                    //CAT 4 - Location
                    campEvent.woFlocType = Location__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Location__r.Name;
                } 
                else if (workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__c != null) {
                    //CAT 3 - Facility
                    campEvent.woFlocType = Facility__c.sObjectType.getDescribe().getLabel();
                    campEvent.woFlocName = workLog.Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__r.Name;
                }
                events.add(campEvent);
            }
        }                                                              
    }
    

    public PageReference ReloadLogEntries(){

        Date currDate = Date.valueOf(CurrentDate);

        LogEntryList = [SELECT Id, Status__c, Work_Order_Activity__r.Name, TimeStamp__c, Duration_Hours__c, 
                               Include_in_Calculation__c, OnEquipment__c, OffEquipment__c, Duration_Text__c,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Name, 
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Location__r.Name,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__r.Name,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__r.Name,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__r.Name,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.System__r.Name,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__r.Name,
                               Work_Order_Activity__r.Status__c,Work_Order_Activity__r.User_Status__c,
                               Work_Order_Activity__r.Operating_Field_AMU__c, Work_Order_Activity__r.Operating_Field_AMU__r.Is_Thermal__c,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c,
                               Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c
                        FROM Work_Order_Activity_Log_Entry__c 
                        WHERE Work_Order_Activity_Log_Lookup__r.Tradesman__c = :TradesmanID 
                        AND Date__c = :currDate
                        //mz 3-Jan-18
                        AND (((Work_Order_Activity__r.Operating_Field_AMU__c != null 
                                AND ((Work_Order_Activity__r.Operating_Field_AMU__r.Is_Thermal__c = true 
                                        AND (Work_Order_Activity__r.User_Status__c LIKE '2SCH %FIX%' 
                                             OR Work_Order_Activity__r.User_Status__c LIKE '3BEX%' 
                                             OR (Work_Order_Activity__r.User_Status__c LIKE '4COM%' 
                                                 AND Work_Order_Activity__r.Status__c = 'Completed'))) 
                                      OR Work_Order_Activity__r.Operating_Field_AMU__r.Is_Thermal__c = false)))
                                OR ((Work_Order_Activity__r.Operating_Field_AMU__c = null 
                                    AND Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c != null 
                                    AND ((Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c = true 
                                            AND (Work_Order_Activity__r.User_Status__c LIKE '2SCH %FIX%' 
                                                 OR Work_Order_Activity__r.User_Status__c LIKE '3BEX%' 
                                                 OR(Work_Order_Activity__r.User_Status__c LIKE '4COM%' 
                                                    AND Work_Order_Activity__r.Status__c = 'Completed'))) 
                                           OR Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__r.Is_Thermal__c = false)))
                                OR (Work_Order_Activity__r.Operating_Field_AMU__c = null 
                                AND Work_Order_Activity__r.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c = null))  
                        ORDER BY TimeStamp__c];
                        
        System.debug(TAG  + ' ReloadLogEntries() -> LogEntryList: ' + LogEntryList);
        
        TotalHours = 0;
        TotalHoursOffEquipment = 0;        
        TotalHoursOnEquipment = 0;        

        WorkOrderSummaryList = new List<WorkOrderSummary>();
        Map<String, WorkOrderSummary> workOrderSummaryMap = new Map<String, WorkOrderSummary>(); 

        for(Work_Order_Activity_Log_Entry__c rec :LogEntryList){
            
            if(rec.Include_in_Calculation__c && rec.Duration_Hours__c <> null){
                TotalHours = TotalHours + rec.Duration_Hours__c;

                if(rec.OffEquipment__c){
                    TotalHoursOffEquipment = TotalHoursOffEquipment + rec.Duration_Hours__c;                    
                }
                if(rec.OnEquipment__c){
                    TotalHoursOnEquipment = TotalHoursOnEquipment + rec.Duration_Hours__c;                    
                }
                WorkOrderSummary workOrderSummaryItem;
                if(workOrderSummaryMap.containsKey(rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c)){
                    
                    workOrderSummaryItem = workOrderSummaryMap.get(rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c);
                    workOrderSummaryItem.Hours += rec.Duration_Hours__c;
                }
                else{
                    
                    workOrderSummaryItem = new WorkOrderSummary();
                    workOrderSummaryItem.WorkOrderName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Work_Order_Number__c;
                    workOrderSummaryItem.WorkOrderId = rec.Work_Order_Activity__r.Maintenance_Work_Order__c;
                    //07-Jun-18 mz:
                    if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__c != null) {
                        //CAT 9 -> Well Event
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Well_Event__r.Name;
                    } 
                    else if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__c != null) {
                        //CAT 8 - Yard
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Yard__r.Name;
                    } 
                    else if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__c != null) {
                        //CAT 7 - FEL
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Functional_Equipment_Level__r.Name;
                    } 
                    else if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__c != null) {
                        //CAT 6 - Subsystem
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Sub_System__r.Name;
                    } 
                    else if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.System__c != null) {
                        //CAT 5 - System
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.System__r.Name;
                    } 
                    else if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Location__c != null) {
                        //CAT 4 - Location
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Location__r.Name;
                    } 
                    else if (rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__c != null) {
                        //CAT 3 - Facility
                        workOrderSummaryItem.LocationName = rec.Work_Order_Activity__r.Maintenance_Work_Order__r.Facility__r.Name;
                    }
                    workOrderSummaryItem.Hours = rec.Duration_Hours__c;
                    workOrderSummaryMap.put(workOrderSummaryItem.WorkOrderName, workOrderSummaryItem);
                    WorkOrderSummaryList.add(workOrderSummaryItem);
                }
            }
        }

        workOrderSummaryList.sort();

        TotalHoursText = VTT_Utilities.HoursToString(TotalHours);
        TotalHoursOnEquipmentText = VTT_Utilities.HoursToString(TotalHoursOnEquipment);        
        TotalHoursOffEquipmentText = VTT_Utilities.HoursToString(TotalHoursOffEquipment);                

        return null;
    }


    //Class to hold calendar event data
    public class calEvent {
        public String title {get;set;}
        public Boolean allDay {get;set;}
        public String startString {get;private set;}
        public String endString {get;private set;}
        public String url {get;set;}
        public String className {get;set;}
        public Id activityId {get; set;} //For Mobile Calendar
        public String woPriorityNumber {get; set;}
        public String woWONumber {get; set;}
        public String woFlocType {get; set;}
        public String woFlocName {get; set;}
    }

    public class WorkOrderSummary implements Comparable{
        public String WorkOrderName {get;set;}
        public String WorkOrderId {get;set;}
        public String LocationName {get;set;}        
        public Decimal Hours {get;set;}

        public Integer compareTo(Object compareTo){
            
            WorkOrderSummary WorkOrderSummaryItem = (WorkOrderSummary) compareTo;
            if (this.WorkOrderName == WorkOrderSummaryItem.WorkOrderName) return 0;
            if (this.WorkOrderName > WorkOrderSummaryItem.WorkOrderName) return 1;
            return -1;        
        }
    }
}